// フラクタルグラフィックス
// 元はX1-turbo/[MZ-2500]/PC-9801用
// i/O ? p274-277
// program  Fractal graphics

enum
	FNTSZ=16
	PAL=256 	:// How many colors ?
endenum
str FONT="Migu-1M-Regular"
font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0)
apage(GPAGE0)
bitmapOpen(0,0,YES)
//
dim int X(2200),Y(2200),Z(2200)
dim int colors(PAL)
int x,y
y=0
for x=0 to PAL-1
	colors(x)=rgb(y,y,y,&hff):// 徐々に明るくなる色
//	print x,hex$(colors(x))
	y=y+256/PAL
next
//
float LX=.57735027,LY=.57735027,LZ=-.57735027
//
//X(1)=320 :Y(1)=30  :Z(1)=0
//X(2)=50  :Y(2)=350 :Z(2)=300
//X(3)=590 :Y(3)=350 :Z(3)=300
X(1)=470 :Y(1)=30  :Z(1)=0
X(2)=50  :Y(2)=500 :Z(2)=450
X(3)=740 :Y(3)=500 :Z(3)=450
//
// 機種別座標変換
float bai=1.0
str dev=devicePlatform()
if (left$(dev,8)="iPhone 6") then {
	bai=375.0/768.0
	if (left$(dev,8)="iPhone 6 P") then {
		bai=414.0/768.0
	}
} else {
	if (left$(dev,4)<>"iPad") then {
		bai=320.0/768.0
	}
}
for x=0 to 3
	X(x)=X(x)*bai
	Y(x)=Y(x)*bai
	Z(x)=Z(x)*bai
next

int NDIM=2:LDRAW()
// main
int level
for level=1 to 6
	NDIM=NDIM*2-1:CALC()
	bitmapWipe()
	locate(0,level+1):print "level";level
	LDRAW()
next
hitKey()
PAINT()
bitmapClose()
end
//
func CALC():// calculate
int i=NDIM
repeat://for i=NDIM to 3 STEP -2
	int k
	for k=MIN(i) to MAXIM(i)
		int PT1=MIN((i+1)/2),PT2=MIN(i)
		X(k)=X(PT1+(k-PT2)/2)
		Y(k)=Y(PT1+(k-PT2)/2)
		Z(k)=Z(PT1+(k-PT2)/2)
		k=k+1:// step 2
	next
	for k=MIN(i)+1 to MAXIM(i)-1
		Z(k)=FRAC_FUNC(X(k-1),X(k+1),Y(k-1),Y(k+1),Z(k-1),Z(k+1))
		X(k)=x:Y(k)=y
		k=k+1:// step 2
	next
	i=i-2
until i<3
//
i=NDIM-1
repeat://for i=NDIM-1 to 2 STEP -2
	for k=MIN(i) to MAXIM(i)-1
		Z(k)=FRAC_FUNC(X(k+i),X(k-i+1),Y(k+i),Y(k-i+1),Z(k+i),Z(k-i+1))
		X(k)=x:Y(k)=y
	next
	PT1=MAXIM(i)
	Z(PT1)=FRAC_FUNC(X(k+i+1),X(k-i),Y(k+i+1),Y(k-i),Z(k+i+1),Z(k-i))
	X(PT1)=x:Y(PT1)=y
	i=i-2
until i<2
endfunc
//
func int FRAC_FUNC(X1,X2,Y1,Y2,Z1,Z2):// X,Y <---  X1,Y1-X2,Y2
	int DX=iabs(X1-X2)
	int DY=iabs(Y1-Y2)
	int DZ=iabs(Z1-Z2)
	x=(X1+X2)/2+DX*.3*(rnd()-.5)
	y=(Y1+Y2)/2+DY*.7*(rnd()-.5)
	return ((Z1+Z2)/2+DZ*.4*(rnd()-.5))
endfunc
//
func LDRAW():// line DRAW
	int i,k
	int rgba=x6816Color2iOSColor(15)
	for i=1 to NDIM-1
		for k=MIN(i) to MAXIM(i)
			bitmapLine(X(k)  ,Y(k) 		,X(k+i)  ,Y(k+i)	,rgba)
			bitmapLine(X(k)  ,Y(k) 		,X(k+i+1),Y(k+i+1)	,rgba)
			bitmapLine(X(k+i),Y(k+i)	,X(k+1+i),Y(k+1+i)	,rgba)
		next:// k
	next:// i
	bitmapImgLoad()
	wait(0.5)
endfunc
//
func PAINT()
	int i,k
	for i=1 to NDIM-1
  		for k=MIN(i) to MAXIM(i)
			TRIANGLE(X(k),Y(k),Z(k),X(k+i)  ,Y(k+i)  ,Z(k+i)  ,X(k+i+1),Y(k+i+1),Z(k+i+1))
			if k=MAXIM(i) then continue
			TRIANGLE(X(k),Y(k),Z(k),X(k+i+1),Y(k+i+1),Z(k+i+1),X(k  +1),Y(k  +1),Z(k  +1))
		next:// k
		wait(0.1)
	next:// i
endfunc
//
func TRIANGLE(X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3)
	int x=(X1+X2+X3)/3,y=(Y1+Y2+Y3)/3,z=(Z1+Z2+Z3)/3:// 三角形の中点
	int S=iabs(X1*(Y2-Y3)+X2*(Y3-Y1)+X3*(Y1-Y2))/2
	if S<3 then return:// 小さすぎる三角形は塗らない
	int rgba=x6816Color2iOSColor(13)
	bitmapLine(X1,Y1,X2,Y2,rgba)
	bitmapLine(X2,Y2,X3,Y3,rgba)
	bitmapLine(X3,Y3,X1,Y1,rgba)
	bitmapPaint(x,y,rgba)
	// brightness calc.
 	int DAX=X2-X1,DAY=Y2-Y1,DAZ=Z2-Z1
	int DBX=X3-X1,DBY=Y3-Y1,DBZ=Z3-Z1
	int VX=DAY*DBZ-DAZ*DBY
	int VY=DAZ*DBX-DAX*DBZ
	int VZ=DAX*DBY-DAY*DBX
	float VNRM = sqr(VX*VX+VY*VY+VZ*VZ)
	float NX=VX/VNRM,NY=VY/VNRM,NZ=VZ/VNRM
	float BR=LX*NX+LY*NY+LZ*NZ
	// print NX,NY,NZ,VNRM
	int col=int(BR*PAL)
	if col<0 then col=0 else if col>PAL-1 then col=PAL-1
	bitmapPaint(x,y,colors(col))
	bitmapImgLoad()
endfunc
//
func int MAXIM(n;int)
	n=n*(n+1)/2
	return(n)
endfunc
//
func int MIN(n;int)
	n=MAXIM(n-1)+1
	return(n)
endfunc
